// |$Id: bargrid.c,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $       |
/* |------------------------------------------------------------|
   | Basic Seismic Utilities (BSU)                              |
   | LANGUAGE: C                                                |
   | AUTHOR: P. MICHAELS    http://cgiss.boisestate.edu/~pm     | 
   | FUNCTION NAME: bargrid.c                                   |
   | DIRECTORY: bsu-2.0.2/src/sublibC4                          |
   |------------------------------------------------------------|
   |  NOTICE:                                                   |
   |  Copyright (C) 2017 Paul Michaels                          |
   |  <pm@cgiss.boisestate.edu>                                 |
   |  This program is free software; you can                    |
   |  redistribute it and/or modify it under the terms          |
   |  of the GNU General Public License as published            |
   |  by the Free Software Foundation; either version           |
   |  3 of the License, or (at your option) any later           |
   |  version.  This program is distributed in the              |
   |  hope that it will be useful, but                          |
   |  WITHOUT ANY WARRANTY; without even the implied            |
   |  warranty of MERCHANTABILITY or FITNESS FOR A              |
   |  PARTICULAR PURPOSE.  See the GNU General Public           |
   |  License for more details.                                 |
   |  You should have received a copy of the GNU                |
   |  General Public License along with this program;           |
   |  if not, write to the Free Software Foundation,            |
   |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
   |------------------------------------------------------------|
   |                                                            |
   | purpose: displays exectution progress grid and             |
   |          computes exbar parameters. (call before           |
   |          calling exbar)                                    |
   |                                                            |
   | output: ntraces =number of traces in data                  |
   |         bar     =pointer  exbar parameter                  |
   |         ibar    =pointer, exbar parameter                  |
   |         invbar  =pointer, exbar parameter                  |
   |                                                            |
   |------------------------------------------------------------|
*/
      #include <stdio.h>
      #include <stdlib.h>
      #include <math.h>

      void bargrid(int ntraces, float *bar, int *ibar, int *invbar)
     {
      int               i;

//...compute exbar parameters
      *bar   = (float) ntraces / 50. ;
      *ibar  = ceil((double)*bar);
      *invbar= floor(1./(double)*bar);

//...display progress grid for exbar
      printf("\n ");
        for (i=10;i<91;i +=10)
       {
        printf("   %2.2d",i);
       }  //  end for
        i=100;
        printf("  %3.3d\n",i);
     }  //  end bargrid
