// |$Id: exbar.c,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $         |
/* |------------------------------------------------------------|
   | Basic Seismic Utilities (BSU)                              |
   | LANGUAGE: C                                                |
   | AUTHOR: P. MICHAELS    http://cgiss.boisestate.edu/~pm     | 
   | FUNCTION NAME: exbar.c                                     |
   | DIRECTORY: bsu-2.0.2/src/sublibC4                          |
   |------------------------------------------------------------|
   |  NOTICE:                                                   |
   |  Copyright (C) 2017 Paul Michaels                          |
   |  <pm@cgiss.boisestate.edu>                                 |
   |  This program is free software; you can                    |
   |  redistribute it and/or modify it under the terms          |
   |  of the GNU General Public License as published            |
   |  by the Free Software Foundation; either version           |
   |  3 of the License, or (at your option) any later           |
   |  version.  This program is distributed in the              |
   |  hope that it will be useful, but                          |
   |  WITHOUT ANY WARRANTY; without even the implied            |
   |  warranty of MERCHANTABILITY or FITNESS FOR A              |
   |  PARTICULAR PURPOSE.  See the GNU General Public           |
   |  License for more details.                                 |
   |  You should have received a copy of the GNU                |
   |  General Public License along with this program;           |
   |  if not, write to the Free Software Foundation,            |
   |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
   |------------------------------------------------------------|
   |                                                            |
   | purpose: displays exectution progress bar on               |
   |          consol (call after each trace processed)          |
   |                                                            |
   | input:  bar     =ntraces/50 switch to control              |
   |                 number of symbol per trace or              |
   |                 traces per symbol.                         |
   |                                                            |
   |         jrec    =trace number just completed               |
   |         ibar    =ceil(bar) int round up                    |
   |         invbar  =floor(1./bar) int round down              |
   |                                                            |
   |------------------------------------------------------------|
*/
      #include <stdio.h>
      #include <stdlib.h>

      int            jw=0;
      void exbar(int ntraces, float bar, int ibar, int invbar, int jrec)
     {
      int            i,jcnt;
      unsigned char symbol=62;   // greater than >>>>   

      if (jw>50) return;
      
        if (bar<=1.0)
       {
        for (i=0; i<invbar; i++)
        {
         printf("%c",symbol);
	 jw=jw+1;
         fflush(stdout);
        } 
       }
        else
       {
        if (jrec%ibar)
          {
           printf("%c",symbol);
	   jw=jw+1;
           fflush(stdout);
          }
       }  // end if
	
//...fixup roundoff
      if (jrec==ntraces && jw<50 )
      { jcnt=50-jw;
        for (i=0; i<jcnt; i++) printf("%c",symbol); 
	fflush(stdout);
      } //end if
	
     }  //  end exbar
