c |$Id: agc.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $               |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: agc.f                                        |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c |                                                            |
c |  agc Automatic Gain Control                                |
c | uses a moving average box car of amplitude^2=energy to     |
c | scale data along time axis (NOT traditional AGC            |
c | with exponential RC decay envelope)                        |
c --------------------------------------------------------------

      subroutine AGC(npts,s1,s2,s3,s4,twide,fsamin)
c
      real*4            s1(*),s2(*),s3(*),s4(*)
c
c...boxit parameters
      iwide=int(twide/fsamin+.5)
      iwide=(iwide/2)*2+1
      isign=-1
      ntimes=1
c
c...compute energy envelope
c
c..energy
      do 50 jt=1,npts
  50  s2(jt)=s1(jt)*s1(jt)
c
c...smooth energy
      call boxit(npts,s2,s3,s4,iwide,isign,ntimes)
c
c...find maximum and convert envelope to amplitude
      fmax=-1.E+20
      do 54 jt=1,npts
c
      if(s3(jt).gt.0.) then
      s3(jt)=sqrt(s3(jt))
      else
      s3(jt)=0.
      endif
c
      if(s3(jt).gt.fmax) then
      fmax=abs(s3(jt))
      endif
  54  continue
c
c...divide by energy envelope
      fnorm=0.
      do 55 jt=1,npts
      if(s3(jt).ne.0.) then
      s4(jt)=(s1(jt)/s3(jt))*fmax
      else
      s4(jt)=0.
      endif
      fnorm=fnorm+s4(jt)*s4(jt)
  55  continue
c
      if(fmax.ne.0.) then
      fnorm=sqrt(fnorm/float(npts))
      else
      fnorm=1.
      endif
c
c...normalize by L2 norm
      do 56 jt=1,npts
      s4(jt)=s4(jt)/fnorm
   56 continue
c
      return
      end
