c |$Id: chktrc.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities (BSU)                              |
c | LANGUAGE: Fortran77                                        |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM: chktrc.f                                          |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c | chktrc.f                                                   |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c | check input file, number of traces, number of samples,     |
c | sample interval, and variables to print progress bar to    |
c | standard output.                                           |
c |------------------------------------------------------------|
c |  Copyright (C) 2017  P. Michaels                           |
c |         All rights reserved                                |
c |  see GNU General Public License, program bmst.f            |
c --------------------------------------------------------------
c
      subroutine CHKTRC(iunit1,icall1,npts,s1,fsamin,infil,
     +bar,invbar,ibar,ntrace,ndim)
c
      include '../Fort/include/bsegy.inc'
c
      real*4            s1(*)
      character*40      infil
      common /header/ hd
c
c...input a trace and check dimensions...
      jrec=1
      CALL BSEGIN(iunit1,ndim,
     +icall1,npts,s1,fsamin,infil,jrec,iexit)
      if(npts.gt.ndim) then
      write(*,*)'  abort---dimensions exceeded'
      stop
      endif
c
c...count traces...
      jrec = 0
      ntr = 0
c     write(*,5)
c 5   format(' Counting traces .....')
 10   jrec = jrec + 1
      call BSEGIN(iunit1,ndim,
     +icall1,npts,s1,fsamin,infil,jrec,iexit)
      if(iexit.eq.1) go to 20
      ntr = ntr + 1
      go to 10
 20   ntrace=ntr
      bar=float(ntrace)/50.
      ibar=int(bar+0.5)
      invbar=int(1./bar+0.5)
c g77 could change recl on fly, but not gfortran
c solution, close unit and reset icall1=0
      close(iunit1)
      icall1=0
      return
      end
