c |$Id: findxyz.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities (BSU)                              |
c | LANGUAGE: Fortran77                                        |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: findxyz.f                                    |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c | get geometry from trace header                             |
c |                                                            |
c --------------------------------------------------------------
c
      subroutine findxyz(sx,sy,sz,sd,rx,ry,rz,frange,rangex)
c
      include '../Fort/include/bsegy.inc'
c
      common /header/ hd
c
c
      if(smul2.lt.0) then
      sx=float(ishlo)/float(abs(smul2))
      sy=float(ishla)/float(abs(smul2))
      else
      sx=float(ishlo)*float(abs(smul2))
      sy=float(ishla)*float(abs(smul2))
      endif
      if(smul1.lt.0) then
      sz=float(ishe)/float(abs(smul1))
      sd=float(ishd)/float(abs(smul1))
      else
      sz=float(ishe)*float(abs(smul1))
      sd=float(ishd)*float(abs(smul1))
      endif
      if(smul2.lt.0) then
      rx=float(irlo)/float(abs(smul2))
      ry=float(irla)/float(abs(smul2))
      else
      rx=float(irlo)*float(abs(smul2))
      ry=float(irla)*float(abs(smul2))
      endif
      if(smul1.lt.0) then
      rz=float(irel)/float(abs(smul1))
      else
      rz=float(irel)*float(abs(smul1))
      endif
      frange=(rx-sx)*(rx-sx) + (ry-sy)*(ry-sy) + (rz-sz+sd)*(rz-sz+sd)
      if(frange.ne.0.0) then
      frange=sqrt(frange)
      else
      frange=0.0
      endif
      rangex=(rx-sx)*(rx-sx) + (ry-sy)*(ry-sy)
      if(rangex.ne.0.0) then
      rangex=sqrt(rangex)
      else
      rangex=0.0
      endif
c
      return
      end
