c |$Id: fold.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: E. A. Robinson (1967, p.29)                        |
c | PROGRAM NAME: shape.f                                      |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c | Copyright (c) 1967 by Holden-Day Inc. 500 Sansome St.,     |
c | San Francisco, all rights reserved                         |
c |                                                            |
c | Holden-Day Inc., Liquidation Trust, 1259 S.W. 14th Street  |
c | Boca Raton, FL 33486 Phone: (561)750-9229 Fax: 561.394.6809|
c |                                                            |
c |    This subroutine is included for distribution with Basic |
c | Seismic Utilities (BSU) by joint permission of the author, |
c | Enders Robinson, and Holden-Day Inc. Liquidation Trust,    |
c | Frederick H. Murphy, Trustee.  Being part of the BSU       |
c | package, it is governed by the terms of the GPL license,   |
c | and is distributed in the hope that it will be useful, but |
c | WITHOUT ANY WARRANTY; without even the implied warranty    |
c | of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    |
c | See the GNU General Public License for more details.       |
c | Paul Michaels, February 2002 <pm@cgiss.boisestate.edu>     |
c |                                                            |
c |------------------------------------------------------------|
c |Minor modifications, Fortran IV to Fortran 77 by P. Michaels|
c |------------------------------------------------------------|
c |                      REFERENCE                             |
c | Robinson, E.A., 1967, "Multichannel Time Series Analysis   |
c |   with Digital Computer Programs", Holden-Day, 298p.       |
c |                                                            |
c |------------------------------------------------------------|
c |  fold: convolves two signals                               |
c |                                                            |
c |------------------------------------------------------------|
c
      subroutine fold(la,a,lb,b,lc,c)
      implicit real*4 (a-h,o-z)
c     real*4 a(la),b(lb),c(lc)
      real*4 a(*),b(*),c(*)
      lc=la+lb-1
      do 1 j=1,lc
    1 c(j)=0.0e+00
      do 2 i=1,la
      do 2 j=1,lb
      k=i+j-1
    2 c(k)=c(k)+a(i)*b(j)
      return
      end
