c |$Id: xcor1.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: xcor1.f                                      |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c | xcor1:  one-sided auto-correlation                         |
c |------------------------------------------------------------|
c |         s=input signal  p=auto-correlation output          |
c |         fsamin=sample interval                             |
c |         tmingt=start time of gate                          |
c |         tmaxgt=end time of gate                            |
c |         mpts=maximum lag in samples  1<mpts<npts           |
c |------------------------------------------------------------|
      subroutine xcor1(npts,s1,p,fsamin,mpts,tmingt,tmaxgt)
      real*4            s1(*),p(*)
c
      jstart=int(tmingt/fsamin+1,4)
      if(jstart.lt.1) jstart=1
      jend=int(tmaxgt/fsamin+1,4)
      if(jend.gt.npts) jend=npts
c
      do 10 k=1,mpts
      p(k)=0.
c
      do 20 j=jstart,(jend-k+1)
   20 p(k)=p(k)+s1(j)*s1(j+k-1)
   10 continue
      end
